#!/bin/sh

ANONUSER="ftp"
INSTALLDIR="/sbin"

clear

if [ "root" != `whoami` ] 
then 
  echo "ERROR: You must run this script as root"
  exit
fi

echo "***************************************"
echo "**** BetaFTPD installation script *****"
echo "***************************************"
echo This scripts install BetaFTPD on puppy
echo " "

#kill the server if it's up (because we are re-runing the script)
ps | egrep "[SR] +$INSTALLDIR/betaftpd" >/dev/null
if [ $? -eq "0" ]
then
  THEPID=`ps | egrep "[SR] +/sbin/betaftpd" | cut -d " " -f 2`
  kill -sTerm $THEPID
  sleep 1
fi



echo Anonymous FTP allows users to access a special directory without having to be a registered user on your system. That directory would be /root/$ANONUSER. 
echo -n "Do you want to allow Anonymous FTP on your server [yes/no]? "

read nnnn
if [ $nnnn = "yes" ]
then
########### user wants anonymous FTP
  grep $ANONUSER /etc/passwd
  if [ $? -eq 0 ] 
  then
    echo -n "The user \"$ANONUSER\" already exists. Everything in the home directory \(/root/$ANONUSER\) will be available to anonymous FTP users. "
    if [ -d /root/$ANONUSER ]
    then
      echo -n "You may want to double-check the contents of that folder just to be sure they are OK to share. "
      echo For your convenience I have a opened a rox-filer windows there.
      rox -d /root/$ANONUSER
    else
      echo I expected to find the home directory for user \"$ANONUSER\" in /root/$ANONUSER but it\'s not there!
    fi
  else 
    echo " "
    echo The way BetaFTPD implements anonymous FTP is by sharing the home directory of the \"$ANONUSER\" user
    if [ -d /root/$ANONUSER ]
    then
      echo The /root/$ANONUSER directory already exists. In order to create the new user I need to rename it to /root/$ANONUSER\_moved
      if [ -d /root/$ANONUSER\_moved ]
      then
         echo The directory /root/$ANONUSER\_moved already exists! you need to do some cleanup to allow me to create a new /root/$ANONUSER.
         echo rerun the script when either /root/$ANONUSER or /root/$ANONUSER\_moved has been removed
         echo Aborting installation of BetaFTPD
         exit
      fi  
      mv /root/$ANONUSER  /root/$ANONUSER\_moved
      if [ -d /root/$ANONUSER\_moved ]
      then
        echo done...
      else
        echo Could not rename /root/$ANONUSER to /root/$ANONUSER\_moved
        echo rerun the script when either /root/$ANONUSER has been removed
        echo Aborting installation of BetaFTPD
        exit
      fi
    fi
    echo The user $ANONUSER doesn\'t exist yet, so we are going to attempt to create it:
    echo The password you choose below will not be needed to log in as anonymous however it *must not* be blank.
    adduser -h /root/$ANONUSER $ANONUSER 
    grep $ANONUSER /etc/passwd > /dev/null
    if [ $? -ne 0 ] 
    then
      echo "??? Can't create user $ANONUSER ??? can\'t enable anonymous FTP"
    fi
  fi




########### user DOES NOT want anonymous FTP
else
  grep $ANONUSER /etc/passwd
  if [ $? -eq 0 ] 
  then
    echo " " 
    echo The user \"$ANONUSER\" exits. This is the user that BetaFTPD uses to provide anonymous FTP access. The user\'s entire home directoy will be shared!
    #' fix beaver syntax highlighting
    echo The user should be removed if you want to prevent anonymous FTP.
    echo "Do you want me to remove the user \"$ANONUSER\"? (the user's home directory /root/$ANONUSER will NOT be touched)"
    #' fix beaver syntax highlighting
    echo -n "Type "no" to abort the script, ENTER to move the directory: " 
    read nnnn
    if [ "$nnnn" = "no" ] 
    then 
      echo Aborting the install script by user request
      echo BetaFTPD cannot prevent anonymous ftp is a user named $ANONUSER exists!
      exit
    fi
    deluser $ANONUSER >/dev/null
    grep $ANONUSER /etc/passwd
    if [ $? -eq 0 ] 
    then
      echo Could not delete user $ANONUSER   
      echo Aborting the install script, BetaFTPD cannot prevent anonymous ftp is a user named $ANONUSER exists!
      exit
    fi
  fi
  echo "Anonymous FTP support is disabled"

fi


###### The actual install 
cp betaftpd $INSTALLDIR/
echo "This directory is the directory shared through anonymous FTP when BetaFTPD is running" >/root/$ANONUSER/readme.txt

###### log file
#  - papaschtroumpf - removed this section since I made a "control panel"
# even though BetaFTPD has no command line options, one of the things that is user controllable is
# whether to enbaled logging or not. The pupppy version BetaFTPD was compiled with --enable-xferlog
# but logging only occurs if the log file already existecho Do you want to have a log of files transfered? it will be in /var/log/xferlog.
#echo Note that there is no mechanism to limit the size of the log file at this time so you will have to manually trim or delete when you think it is too big.
#echo -n "Enter yes to enable logging: "
#read nnnn
#if [ $nnnn = "yes" ]
#then
#  echo "# This is the BetaFTPD transfer log" >/var/log/xferlog
#  echo "# Format: <date> <xfer time> <IP address> <xfer size> <filename> b _ <iNPUT/oUTPUT> a <owner> ftp 0 *" >> /var/log/xferlog
#  echo Logging enabled in /var/log/xferlog
#else
#  echo Removing old transfer log
#  rm -rf /var/log/xferlog
#  rm -rf /usr/adm/xferlog
#fi


##### autostart
# not working at this time, the netowrk is not up when rc.local is executed.
# echo -n "Do you want BetaFTPD to start every time you start puppy? [yes/no]: "
# read nnnn
# if [ $nnnn = "yes" ]
# then
# else
# fi

##### menus
# we plave ourselves immediately beofre the LinPopUp menu item
# The menu item will bring up a script that allows managing the server
FVWM95RC="/root/.fvwm95rc"
# if somehow the script got ran multiple times we could keep adding
# more instances: don't do that
echo " "
grep "betaftpd-cc" $FVWM95RC
if [ $? -ne 0 ] ;then
  cp -f $FVWM95RC /tmp/DOTfvwm95.ftpd.backup
  EDITTEXT="s/^\(.\+Exec LinPopUp\)/+ \"BetaFTPD FTP server%pc-2x.xpm%\" Exec exec \/sbin\/betaftpd-cc\n\1/"
  sed -e "$EDITTEXT" $FVWM95RC >/tmp/betaftpdinstall.tmp
  mv -f /tmp/betaftpdinstall.tmp $FVWM95RC
else
  echo "menu entry already in-place, skipping menu insertion"
fi
cp betaftpd-cc $INSTALLDIR
sync
echo -n "If you are running fvwm95, BetaFTPD has been added to the menus under Networking - You mave have to restart the Windows Manager before the menu items actually appers. for example in fvwm95, choose Start->Shutdown->Fvwm95 restart. "
echo "A copy of the original .fvwm95 config file has been saved as /tmp/DOTfvwm95.ftpd.backup"
echo " "
echo Press ENTER to launch the BetaFTPD Control Center.
read nnnn
exec $INSTALLDIR/betaftpd-cc

